image: maven:3.9.5-eclipse-temurin-21-alpine

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=maven.repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN"
  
cache:
    key: "$CI_COMMIT_REF_NAME"
    paths:
        - maven.repository/
        - target/

before_script:
    - export MAVEN_USER_HOME=`pwd`/.maven
        
maven-install:
    stage: build
    script:
        - mvn install -s ci_settings.xml

maven-site:
    stage: deploy
    only:
      refs:
        - develop        
        - tags
    script:
      - 'mvn verify site:site site:stage -s ci_settings.xml -Plibrary-site'
    artifacts:
      paths:
          - target/staging

maven-deploy:
    stage: deploy
    only: # do not run on feature branch, because it's not  protected and the private.key will not be available!
      - develop
      - tags
      - /^feature\/.*/
    before_script:
        - apk update 
        - apk fetch gnupg
        - apk add gnupg        
        - gpg --version |grep gpg |cut -d " " -f 3
        - gpg --import public.key
        - gpg -v --import --no-tty --batch --yes <(echo "$SSH_PRIVATE_KEY")
    script:
        - mvn deploy -s ci_settings.xml -Dgpg.passphrase=$passphrase -Ppublic-deploy-groupId-naturzukunft
